#ifndef MEMORYDC_INCLUDED
#define MEMORYDC_INCLUDED

class MEMDC
{
public:
	MEMDC()
	{
		hdcMem = 0;
	}

	~MEMDC()
	{
		cleanup();
	}

	void init(HDC hdc, int width, int height)
	{
		cleanup();

		hdcMem = CreateCompatibleDC(hdc);
		hbmMem = CreateCompatibleBitmap(hdc, width, height);

		hbmOld = SelectObject(hdcMem, hbmMem);
	}

	void cleanup()
	{
		if(hbmMem)
		{
			SelectObject(hdcMem, hbmOld);
			DeleteObject(hbmMem);
			hbmMem = 0;
		}

		if(hdcMem)
		{
			DeleteDC(hdcMem);
			hdcMem = 0;
		}
	}

	HBITMAP bitmap()
	{
		return hbmMem;
	}

	operator HDC() { return hdcMem; }
	operator DWORD() { return (DWORD)hdcMem; }

private:
	HBITMAP	hbmMem;
	HDC		hdcMem;
	HANDLE	hbmOld;

};

#endif