//
//	wincap.c
//
//	Wrapper exe which injects the capture dll
// 
//	v1.0 Mr Bigglesworth ;-)
//
#include <windows.h>
#include <stdio.h>

#pragma comment(linker, "/OPT:NOWIN98")

#define CAPTUREAPI "CaptureWindow"
#define CAPTUREDLL "capture.dll"

BOOL EnablePrivilege(TCHAR *szPrivName, BOOL fEnable)
{
	TOKEN_PRIVILEGES tp;
	LUID   luid;
	HANDLE hToken;

	TOKEN_PRIVILEGES oldtp;
	DWORD len = sizeof(oldtp);

	if(!LookupPrivilegeValue(NULL, szPrivName, &luid))
		return FALSE;

	tp.PrivilegeCount			= 1;
	tp.Privileges[0].Luid		= luid;
	tp.Privileges[0].Attributes = 0;

	if(!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
		return FALSE;

	if(0 == AdjustTokenPrivileges(hToken, FALSE, &tp, sizeof(tp), &oldtp, &len))
		return FALSE;

	oldtp.PrivilegeCount = 1;
    oldtp.Privileges[0].Luid = luid;

	if(fEnable)
		oldtp.Privileges[0].Attributes |=  SE_PRIVILEGE_ENABLED;
	else
		oldtp.Privileges[0].Attributes &= ~SE_PRIVILEGE_ENABLED;

	if(0 == AdjustTokenPrivileges(hToken, FALSE, &oldtp, sizeof(oldtp), &tp, &len))
		return FALSE;

	CloseHandle(hToken);

	return TRUE;
}

BOOL EnableDebugPrivilege()
{
	return EnablePrivilege(SE_DEBUG_NAME, TRUE);
}


//
// Inject the specified DLL into the target process.
//
// hProcess - must have sufficient rights (see main)
// szModule - FULL path to DLL to inject
//
// returns the HMODULE of new DLL, in the context of the
//  TARGET process
//
HMODULE WINAPI InjectDll(HANDLE hProcess, LPCTSTR szModule)
{
	PVOID   buf;
	ULONG bufsize;
	HANDLE  hThread;
	HMODULE hModule = 0;
	
	if(hProcess == 0 || szModule == 0)
		return FALSE;
	
	bufsize = lstrlen(szModule) + 1;
	
	// Allocate memory for DLL name
	if((buf = VirtualAllocEx(hProcess, 0, bufsize, MEM_RESERVE|MEM_COMMIT, PAGE_READWRITE)) == NULL)
	{
		return 0;
	}
	
	// Store the DLL name
	if(!WriteProcessMemory(hProcess, buf, szModule, bufsize, 0))
	{
		VirtualFreeEx(hProcess, buf, 0, MEM_RELEASE|MEM_DECOMMIT);
		return 0;
	}
	
	// Create the thread in target process
	hThread = CreateRemoteThread(hProcess, 0, 0, (LPTHREAD_START_ROUTINE)LoadLibrary, buf, 0, 0);
	
	if(hThread != 0)
	{
		// Wait for thread (and DllMain) to exit
		WaitForSingleObject(hThread, INFINITE);
		
		// Get return code of LoadLibrary
		GetExitCodeThread(hThread, (DWORD *)&hModule);
		CloseHandle(hThread);
	}
	
	// Free buffer
	VirtualFreeEx(hProcess, buf, 0, MEM_RELEASE);
	
	return hModule;
}

//
// Unload a DLL previously injected with InjectDll
//
BOOL WINAPI UnloadInjectedDll(HANDLE hProcess, HMODULE hModule)
{
	HANDLE hThread;
	BOOL   fSuccess = FALSE;
	
	if(hProcess == 0 || hModule == 0)
		return FALSE;
	
	// Call FreeLibrary in target process
	hThread = CreateRemoteThread(hProcess, 0, 0, (LPTHREAD_START_ROUTINE)FreeLibrary, hModule, 0, 0);
	
	if(hThread != 0)
	{
		// Wait for thread (and DllMain) to exit
		WaitForSingleObject(hThread, INFINITE);
		
		// Get return code of FreeLibrary
		GetExitCodeThread(hThread, (DWORD *)&fSuccess);
		CloseHandle(hThread);
	}
	
	return fSuccess;
}

DWORD WINAPI CallRemoteProc(HANDLE hProcess, HMODULE hModule, LPCTSTR szModule, LPCTSTR szFunction, DWORD param)
{
	HMODULE hDummy  = LoadLibraryEx(szModule, 0, DONT_RESOLVE_DLL_REFERENCES);
    DWORD   offset  = (DWORD)GetProcAddress(hDummy, szFunction) - (DWORD)hDummy;
    DWORD   realfunc = (PVOID)((DWORD)hModule + offset);
    HANDLE  hThread;

	DWORD	retval = 0;

	GetProcAddress(hDummy, szFunction);

	FreeLibrary(hDummy);

    hThread = CreateRemoteThread(hProcess, 0, 0, (LPTHREAD_START_ROUTINE)realfunc, (PVOID)param, 0, 0);

    if(hThread != 0)
    {
        GetExitCodeThread(hThread, &retval);
		WaitForSingleObject(hThread, INFINITE);
        CloseHandle(hThread);
    }

    return retval;
}

void FindModuleFileName(char *szFileName, char *szPath)
{
	// Look for file in current directory
	if(GetFileAttributes(szFileName) != INVALID_FILE_ATTRIBUTES)
	{
		lstrcpy(szPath, szFileName);
	}
	else
	{
		// look for debug/filename  or release/filename
		char temp[MAX_PATH];
#ifdef _DEBUG
		wsprintf(temp, "debug\\%s", szFileName);
#else
		wsprintf(temp, "release\\%s", szFileName);
#endif

		if(GetFileAttributes(temp))
			lstrcpy(szPath, temp);
		else
			lstrcpy(szPath, "");
	}
}
//
//	Usage:   wincap <hwnd>
//
int main(int argc, char *argv[])
{
	int     pid;
	HANDLE  hProcess;
	HMODULE hRemoteModule;
	HWND	hwnd;
	char    szModule[MAX_PATH] = CAPTUREDLL;
	char	szPath[MAX_PATH];
	char	*fp;
	DWORD	dwAccessRights = PROCESS_CREATE_THREAD | PROCESS_VM_OPERATION | PROCESS_VM_WRITE;
	
	EnableDebugPrivilege();

	if(argc != 2)
	{
		printf("Usage: wincap [hwnd]\n\n");
		return 0;
	}

	FindModuleFileName(CAPTUREDLL, szModule);

	// get the window handle from command-line
	sscanf(argv[1], "%x", &hwnd);

	// get process-id from window handle
	if(!GetWindowThreadProcessId(hwnd, &pid))
	{
		printf("Failed to locate window: %x\n", hwnd);
		return 0;
	}
	
	// open process so we can inject into it
	if((hProcess = OpenProcess(dwAccessRights, FALSE, pid)) == 0)
	{
		printf("Failed to open process: %d\n", pid);
		return 0;
	}
	
	// Inject DLL
	GetFullPathName(szModule, MAX_PATH, szPath, &fp);

	printf("Loading:    %s\n", szPath);

	hRemoteModule = InjectDll(hProcess, szPath);

	if(hRemoteModule != 0)
	{
		printf("Loaded:     %s\n", szModule);

		// do the capture
		printf("Executing:  %s!%s\n", szModule, CAPTUREAPI);
		
		CallRemoteProc(hProcess, hRemoteModule, szPath, CAPTUREAPI, (DWORD)hwnd);

		// unload!!
		printf("Unloading:  %s\n", szModule);
		UnloadInjectedDll(hProcess, hRemoteModule);

		printf("\nCheck Windows Clipboard for results\n");
	}
	else
	{
		printf("Failed to load: %s\n", argv[2]);
		return 0;
	}

	CloseHandle(hProcess);

	return 0;
}
